ext WaitTimer_

tempo equ 160

dseg
SoundProc:
    defw 0
time:
    defw 0
CurrentPtr:
    defw 0
zseg
Length:
    defb 0

cseg

InitSound_: public InitSound_
    lxi h,0
    shld SoundProc
    shld CurrentPtr
ret


CallSound_: public CallSound_
    push b
        lbcd SoundProc
        mov a,c
        ora a,b
        skz | calb
        lxi b,0
        sbcd SoundProc
    pop b
ret


ToneOn:
    push h
        di
            lxi h,$3600
            mvix h,$02
            do
                skit f1
            repeat
            mvix h,$80
            do
                skit f1
            repeat
            stax h
            do
                skit f1
            repeat
            mvix h,$15
            do
                skit f2
            repeat
        ei
    pop h
ret


ToneOff:
    push h
        di
            lxi h,$3600
            mvix h,$00
            do
                skit f2
            repeat
        ei
    pop h
ret


Sound_Hit_: public Sound_Hit_
    push v
        mvi a,240
        do
            call ToneOn
            ex
                mvi a,1
                call WaitTimer_
            ex
            sui a,10
            lti a,100
        repeat
        call ToneOff
    pop v
ret


Sound_Loose_: public Sound_Loose_
    push v
        mvi a,250
        call ToneOn
        mvi a,1
        call WaitTimer_
        call ToneOff
        mvi a,1
        call WaitTimer_
    pop v
ret


Sound_Beep_: public Sound_Beep_
    push v
        mvi a,121
        call ToneOn
        mvi a,1
        call WaitTimer_
        call ToneOff
    pop v
ret


Melody: 
    shld CurrentPtr
    mviw Length,1
    do
        lhld CurrentPtr
        mov a,l
        ora a,h
    while sknz
        lhld time
        mov a,l | adi a,low -tempo | mov l,a
        mov a,h | aci a,high -tempo | mov h,a
        if sknc
            push h
                shld time
                lhld CurrentPtr
                mov a,l | ora a,h
                if sknz
                    dcrw Length
                    if skz
                        continue:
                        ldax h+
                        if eqi a,0
                            ; end
                            mov CurrentPtr,a | mov CurrentPtr+1,a
                            call ToneOff
                            jr next
                        endif
                        staw Length
                        ldax h+
                        shld CurrentPtr
                        if nei a,0
                            dcr a
                            adi a,low cycles | mov l,a
                            mvi a,0 | aci a,high cycles | mov h,a
                            ldax h
                            call ToneOn
                        else
                            call ToneOff
                        endif
                    endif
                endif
                next:
            pop h
            mov a,l | adi a,low 250 | mov l,a
            mov a,h | aci a,high 250 | mov h,a
        endif
        shld time
        mvi a,1
        call WaitTimer_
    wend
ret


start_notes: 
	defb 6,0, 5,C5,1,0, 5,C5,1,0, 5,C5,1,0
	defb 5,C5,1,0, 11,G4,1,0, 11,C5,1,0
	defb 5,C5,1,0, 5,D5,1,0, 5,C5,1,0, 11,D5,1,0
	defb 11,E5,1,0, 47-15,C5,1+15,0
    defb 0
Sound_Start_: public Sound_Start_
    push h
        lxi h,start_notes
        call Melody
    pop h
ret


clear_notes: 
	defb 5,C4,1,0, 5,E4,1,0, 5,G4,1,0, 5,D4,1,0
	defb 5,F4,1,0, 5,A4,1,0, 5,E4,1,0, 5,G4,1,0
	defb 5,B4,1,0, 17,C5,1,0
    defb 0
Sound_Clear_: public Sound_Clear_
    push h
        lxi h,clear_notes
        call Melody
    pop h
ret


over_notes: 
	defb 5,C5,1,0, 5,C5,1,0, 5,G4,1,0, 5,G4,1,0
	defb 5,A4,1,0, 5,A4,1,0, 5,B4,1,0, 5,B4,1,0
	defb 30,C5,18,0
    defb 0
Sound_GameOver_: public Sound_GameOver_
    push h
        lxi h,over_notes
        call Melody
    pop h
ret


G3 equ 1
G3S equ 2
A3 equ 3
A3S equ 4
B3 equ 5
C4 equ 6
C4S equ 7
D4 equ 8
D4S equ 9
E4 equ 10
F4 equ 11
F4S equ 12
G4 equ 13
G4S equ 14
A4 equ 15
A4S equ 16
B4 equ 17
C5 equ 18
C5S equ 19
D5 equ 20
D5S equ 21
E5 equ 22
F5 equ 23
F5S equ 24
G5 equ 25

N8 equ 6
N8P equ N8*3/2
N4 equ N8*2
N4P equ N4*3/2
N2 equ N4*2
N2P equ N2*3/2
N1 equ N2*2

cycles:
defb 242 ; G3
defb 229 ; G3S
defb 216 ; A3
defb 204 ; A3S
defb 192 ; B3
defb 182 ; C4
defb 171 ; C4S
defb 162 ; D4
defb 153 ; D4S
defb 144 ; E4
defb 136 ; F4
defb 128 ; F4S
defb 121 ; G4
defb 114 ; G4S
defb 108 ; A4
defb 102 ; A4S
defb 96 ; B4
defb 91 ; C5
defb 86 ; C5S
defb 81 ; D5
defb 76 ; D5S
defb 72 ; E5
defb 68 ; F5
defb 64 ; F5S
defb 61 ; G5
