include "Vram.inc"
include "Chars.inc"
include "Sprite.inc"

SpriteLeft equ LeftOrgin*16/2+4
SpriteTop equ TopOrgin*16-4
StageSpriteY equ 12

dseg
pNextCellChar:
    defw 0
backgroundY:
    defb 0
backgroundX:
    defb 0


; ptr<byte> SpritePtr(byte index);
cseg
SpritePtr_: public SpritePtr_
    push b
        mvi c,0
        shal | rcl
        shal | rcl
        mov l,a
        mov a,c
        adi a,high Attribute
        mov h,a
    pop b
ret


ShowSprite: ; a,d,e,b,c
    push b
        mvi c,0
        shal | rcl ;*2
        shal | rcl ;*4
        mov l,a
        mov a,c
        adi a,high Attribute
        mov h,a
    pop b
    di        
        mov a,e ; y
        adi a,SpriteTop
        ori a,$01
        stax h+

        mov a,c ; color
        stax h+

        mov a,d ; x
        adi a,SpriteLeft
        ani a,$fe
        stax h+

        mov a,b ; pattern
        shal
        stax h
    ei
ret


; void ShowSprite(ptr<Movable> pMovable, byte pattern, byte color);
cseg
ShowSprite_: public ShowSprite_
    push v | push h | push d | push b
        mov a,e ; pattern
        mov b,a

        ldax h+ | mov d,a ; x
        
        ldax h+ ; y
        push b
            mov e,a
            mvi c,0
            shal | rcl ;*2
            add a,e | aci c,0 ;*3
            shcr | rar ;/2
            adi a,StageSpriteY
            mov e,a ; y
        pop b
        
        ldax h ; index
        
        call ShowSprite
    pop b | pop d | pop h | pop v
ret


; void ShowSpriteXY(byte index, byte x, byte y, byte pattern, byte color);
dseg
ShowSpriteXY_@Param3: public ShowSpriteXY_@Param3
    defb 0
ShowSpriteXY_@Param4: public ShowSpriteXY_@Param4
    defb 0
cseg
ShowSpriteXY_: public ShowSpriteXY_
    push v | push h | push d | push b
        push v
            mov a,e | mov d,a ; x
            mov a,c | mov e,a ; y
            mov b,ShowSpriteXY_@Param3
            mov c,ShowSpriteXY_@Param4
        pop v
        call ShowSprite
    pop b | pop d | pop h | pop v
ret


; void HideSprite(byte index);
cseg
HideSprite_: public HideSprite_
    push v | push h
        call SpritePtr_
        mvix h,0     
    pop h | pop v
ret


; void HideAllSprites();
cseg
HideAllSprites_: public HideAllSprites_
    calt $8e
ret


; void PutSprite(byte x, byte y, byte c, byte color);
dseg
PutSprite_@Param3: public PutSprite_@Param3
PutSprite_color:
    defb 0
cseg
PutSprite_: public PutSprite_
    push v | push h | push d | push b
        mov d,a ; x
        mov a,e ; y
        add a,a ;*2
        add a,e ;*3
        add a,a ;*6
        add a,a ;*12
        mov e,a
        add a,d ; index
        push v
            mov a,d
            add a,a ;*2
            add a,a ;*4
            add a,a ;*8
            add a,a ;*16
            mov d,a ; x

            mov a,e
            add a,a
            adi a,StageSpriteY+12
            mov e,a ; y
            
            mov a,c ; pattern
            mov b,a

            mov c,PutSprite_color
        pop v
        call ShowSprite
    pop b | pop d | pop h | pop v
ret
